/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
function noError(){return true;}

(function() {
dojo.provide("com.ibm.rational.carter.ide.client.reviews.ReviewWidget");
/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");
dojo.require("rmps.app.pickers.internal.SelectionsPicker");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojox.html");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.hash");

dojo.require("rmps.core.RootServices");

dojo.require("dm.review.app.ui.internal.editors.ReviewEditor");
dojo.require("rmps.core.review.util.ReviewUtil");
dojo.require("rmps.app.core.util");

dojo.require("rmps.core.BackendScr");

dojo.require("rmps.ui.editor.EditorUtil");

//reviews
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");
dojo.require("dm.review.app.ui.internal.editors.ReviewEditorInput");
dojo.require("dm.review.app.ui.internal.editors.RegisterReviewEditorsInitializer");
//dojo.require("com.ibm.rational.carter.ide.client.reviews.RhpRegisterReviewEditorsInitializer");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

dojo.require("rmps.core.review.ReviewClient");
var ReviewClient = rmps.core.review.ReviewClient;
dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");
var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

//dojo.require("com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient");
//var ResourceInfoClient2 = com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient;

dojo.require("rmps.app.ui.internal.util.UrlUtil");
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");

dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

dojo.require("rmps.core.streams.StreamClient");

var StreamClient = rmps.core.streams.StreamClient;
dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("rmps.ui.resource.ResourceIconLabel");

dojo.require("rmps.app.ui.internal.comment.SketchContribution");

dojo.require("com.ibm.rational.carter.ide.client.context.contextHelper");
var contextHelper = com.ibm.rational.carter.ide.client.context.contextHelper;

//overriding the ReviewActionsRegistery.getResourceUrl to support our url style.
dojo.require("dm.review.app.util.ReviewActionsRegistery");
var ReviewActionsRegistery= dm.review.app.util.ReviewActionsRegistery;

dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
var DesignUtil= rmps.app.ui.internal.pages.design.DesignUtil;

dojo.require("rmps.core.review.ReviewClient");
var ReviewClient = rmps.core.review.ReviewClient;

//dojo.require("rmps.viewlets.internal.reviews.ReviewsViewlet");
dojo.require("com.ibm.rational.carter.ide.client.reviews.ReviewTable");
dojo.declare("com.ibm.rational.carter.ide.client.reviews.ReviewWidget", [dijit._Widget, dijit._Templated], {
	
	"class": "root",
	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "reviews/templates/ReviewWidget.html"),
	
	// private properties
	_projectArea: null,
	_baseline: null,
//	_resource: null,

	_connectionWidget: null,	

	_reviewTable: null,	
	_reviewEditor: null,
	_editorUtil: null,
	_editorInput: null,
	_reviewUri: null,
	reviewTableHeader:null,
//	_newReviewCreated: false,
	_toolbarContainer:null,
	newButton:null,
	_mediator:null,
	

	


	constructor: function(params){
		window.onerror = noError;
		this.mediator = new com.ibm.rational.carter.ide.client.reviews.ReviewWidget._Mediator();
		//patch to allow reviewing reviews defined on baselines.
		rmps.core.review.util.ReviewUtil.isBaselineMatches = function(review) {
			return true;
		};
    },
	
	buildRendering: function() {
		this.inherited(arguments);
		this.containerNode = this.domNode;
	},
	
	postCreate: function() {
		
		//triggers the login window if needed
		if (RhpCommunicator.login() == false) {
			return;
		}

		contextHelper.init(true);
		var deferred = RhpProjectAreaInfo.init();
		//deferred.addCallback(this,this.initUser);
		deferred.addCallback(this,this.init);
		ReviewActionsRegistery.getFullEditResourceUrl= dojo.hitch(this, this.getFullEditResourceUrl);

	},
	
	//overriding the ReviewActionsRegistery.getResourceUrl to support our url style.
	getFullEditResourceUrl: function(reviewController, resourceUri) {
		var fullEditResourceUrl = net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL+ "/web/projects/"+ reviewController.context.name;
		var bl = jazz.app.context.get().baseline; 
		if (bl != null) {
			fullEditResourceUrl += "?oslc_config.context=" + bl;
			var cs = jazz.app.context.get().changeset;
			if (cs != null && cs != "")
				fullEditResourceUrl += "&changeset=" + cs ;
			
		}
 		return fullEditResourceUrl + DesignUtil.getEditResourceUri(resourceUri);
		//return reviewController.getProjectPrefix() + DesignUtil.getEditResourceUri(resourceUri);
		
	},
				
	_onClickTableHeader: function(){
		if (this.reviewTableContainer.style.display=="none")
			this.reviewTableContainer.style.display="inline";
		else
			this.reviewTableContainer.style.display="none";
	},

	createConnectionWidget: function() {
		if (this._connectionWidget == null) {
			this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget();
			this.connectionContainer.appendChild(this._connectionWidget.domNode);
			//dojo.connect(this._connectionWidget, "_onSelectProject", this, this.initProjectAreaSelection);
			dojo.connect(this._connectionWidget, "_onSelectBaseline",this,this._onSelectBaseline);
			if (this._connectionWidget._currentProjectArea != null && this._connectionWidget._currentContext != null)
				this._onSelectBaseline(this._connectionWidget._currentProjectArea, this._connectionWidget._currentContext);

			

		} 

	},

	_onSelectBaseline: function(projectArea, baseline)
	{
		//the table view isn't baseline sensitive, it's showing all reviews from project
		//therefore no need to recreate on baseline change.
		var needToRecreate = false;
		if (this._projectArea != projectArea)
			needToRecreate = true; 
		
		this._projectArea = projectArea;
		this._baseline = baseline;
		
		contextHelper.setContext(this._projectArea, this._baseline);

		if (this._projectArea != null && this._baseline != null) 
		{
			if (needToRecreate) {
				this.createViewlet();
				if (this.newButton)
					this.newButton.setEnabled(true);
			}	
		}
		else {
			if (this.newButton)
				this.newButton.setEnabled(false);
			this.removeViewlet();
		}
	},
	
	closeReviewEditor: function(){
		
		if (this._editorUtil != null) {
//			alert("clear started");
			//var reviewEditor = this._editorUtil.getEditor(this._editorInput);
			if (this._editorInput != null)
			{
				//if (this._reviewEditor)
					//this._reviewEditor.destroy();
				this._editorUtil.closeEditorInput(this._editorInput, true,true);
				this._editorInput = null;
				this._reviewEditor = null;
//				alert("clear succeeded");
			}
		}
	},
	destroy: function() {
		this.closeReviewEditor();
		this.inherited(arguments);
	},
	destroyRecursive: function() {
		
//		this.closeReviewEditor();
//		alert("destorying");
//		this.inherited(arguments);
//		alert("succeeded");
	},
	_onNewReview: function(){

		//Will be needed for RC2
		window.location.href = "#resourceUri=" + rmps.app.ui.ReviewEditorUtil.NEW_REVIEW_EDITOR;
		//rmps.app.ui.ReviewEditorUtil.createReview();
		
		//this._onRefreshViewlet();
	},
	
	showReviewEditor: function() {
//		}
		if (this._editorUtil == null) {
			this._editorUtil = rmps.ui.editor.EditorUtil.getInstance(this._reviewUri,this.reviewEditorContainer);
			dojo.connect(this._editorUtil, "onEditorOpened", this, this._onEditorOpened);
			dojo.connect(this._editorUtil, "onEditorClosed", this, this._onEditorClosed);
			this._editorUtil.domNode = this.reviewEditorContainer;
			this._editorUtil.containerNode = this.reviewEditorContainer;
		}
		this.closeReviewEditor();
		var args = {
			resourceUri: this._reviewUri, 
			resourceInfo:this._reviewUri,
			tab:"main",
			type:"reviewDiagram",
			mediator: this.mediator
		};
		
		if (rmps.app.ui.ReviewEditorUtil.NEW_REVIEW_EDITOR != this._reviewUri)
		{
			var deferred = ReviewClient.getReview(this._reviewUri, null, true);
			
			deferred.addCallback(this, function(review){
				//add set changeset
				this._editorInput = new dm.review.app.ui.internal.editors.ReviewEditorInput(args);
				this.updateContextAccordingToReview(review);
				this._editorUtil.openEditor(this._editorInput);
			});
		}
		else
		{
			jazz.app.context.get().changeset = "";
			this._editorInput = new dm.review.app.ui.internal.editors.ReviewEditorInput(args);
			this._editorUtil.openEditor(this._editorInput);
		}
	},
	
	updateContextAccordingToReview: function(review) 
	{
		if (review)
		{
			var reviewContext = review.getReviewAttribute("reviewBaseline");
			
			if(!this.reviewController && this._editorInput) // only for _ajax-modules (rhapsody client)
				this.reviewController = rmps.core.review.ReviewController.getInstance(review.uri, this._editorInput);
			
			reviewContext = this.reviewController.getActualContextUri(reviewContext);
			if (!(reviewContext && reviewContext.indexOf("/changeset/")>-1))
				this._onSelectBaseline(this._projectArea, reviewContext);
				
			jazz.app.context.get().baseline = review.getReviewAttribute("reviewBaseline");
		}
	},
	_onEditorOpened: function(editor)
	{
		this._reviewEditor = this._editorUtil.getEditor(this._editorInput);
		this._fixEditor(this._reviewEditor);
		//to resize comments view.
		this._reviewEditor.accordion.resize({h:450,w:240});
		//dojo.connect(this._reviewEditor, "onTabChange", this, this._resizeReviewEditor);
		//to trigger the population of the resources tab
		this._reviewEditor.resize();
	},
	
	_resizeReviewEditor: function()
	{
		if (this._reviewEditor != null)
			this._reviewEditor.resize();
		
	},
	_fixEditor: function(editor)
	{
		editor.destroyRecursive = dojo.hitch(editor, function(){
			this.removeCommentingWidgets();
			this.inherited("destroyRecursive", arguments);
		});

		editor.destroy = dojo.hitch(editor, function(){
			this.removeCommentingWidgets();
			if(this.reviewMessageBox){
				this.reviewMessageBox.destroy();
			}
			if(this._breadCrumbs){
				this._breadCrumbs.destroy();
			}
			if(this.accordion){
				this.accordion.destroy();
			}
			if(this.selectionCommentingWidget){
				this.selectionCommentingWidget.destroy();
			}
	
			this.inherited("destroy",arguments);
			this.callBacks= null;
		});
	
		editor.removeCommentingWidgets = dojo.hitch(editor, function(){
			/*We have to remove the commenting widget from the children as it will be destroyed later by the parent class. Otherwise, there will be an extra
			 * attemp to detroy  commentingWidget in a lter call for destroyRecursive, and this will cause an error*/
			if(this.commentingWidget){
				var children= this.accordion.getChildren();
				for(var index=0 ;index< children.length; index++){
					var current= children[index];
					if(current==this.commentingWidget){
						this.accordion.removeChild(this.commentingWidget);
					}else if(current==this.selectionCommentingWidget){
						this.accordion.removeChild(this.selectionCommentingWidget);
						this.selectionCommentingWidget.destroy();
						delete this.selectionCommentingWidget;
					}
				}
			}
		});
		
	},
	_onEditorClosed: function(editor)
	{
		if (this._reviewEditor == editor)
		{
			//refresh viewlet when editor is closed
			//closing editor probably means the review is deleted
			//todo: find a better way to be noticed on deletion of review.
			var deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, this._onRefreshViewlet),0);
			return deferred;
						
		}

	},


	init: function() {
		
		this.createConnectionWidget();
		this.createViewletToolbar();
		dojo.connect(this.reviewTableHeader, "onclick", this, this._onClickTableHeader);
		//subscribe to show in browser event.		
		 dojo.subscribe("rmps.web.app.explorer.show", this, function(resourceUri){
		 	if (resourceUri != null) {
				RhpCommunicator.notifyRhapsody({
					cmd: "ShowInExplorer",
					params:[resourceUri.uri]
				});
			}
 		});

		//subscribe on has change to catch pageSize changes
		dojo.subscribe("/dojo/hashchange", this, "onHashChange");
		this.onHashChange();
		

		
	},
	_onRefreshViewlet: function() {
		this.removeViewlet();
		this.createViewlet();
	},
	
	removeViewlet: function()
	{
		this._reviewTable = null;
		// clear whatever was previously displayed && display new widget
		if (this.reviewTableContainer != null) {
			while (this.reviewTableContainer.hasChildNodes()) {
				this.reviewTableContainer.removeChild(this.reviewTableContainer.firstChild);
			}
		}
	},

	createViewlet: function() {
		if (this._reviewTable != null && 
			(this._reviewTable._projectArea != this._projectArea ||
			this._reviewTable._baseline != this._baseline))
		{
			this.removeViewlet();
		}
		if (this._reviewTable == null) {
			this._reviewTable = new com.ibm.rational.carter.ide.client.reviews.ReviewTable({
				_projectArea: this._projectArea,
				_baseline: this._baseline,
				_user: contextHelper._currentUser,
				itemsPerPage: 5,
			});//
			this.reviewTableContainer.appendChild(this._reviewTable.domNode);
		}

		
	},
	createViewletToolbar: function()
	{
		if (this.toolbar != null)
			return; 

		// toolbar
		this.toolbar = new jazz.ui.SimpleToolbar();
		this.toolbar.containerNode = this.toolbar.domNode;
		
		if (dojo.isIE < 8) {
			this._toolbarContainer.insertBefore(this.toolbar.domNode, this.messageBox.domNode);
		} else {
			this._toolbarContainer.appendChild(this.toolbar.domNode);
		}
		this.addButtonsViewlet(this.toolbar);
	},

	addButtonsViewlet: function(toolbar) {
		
		this.newButton = toolbar.addWidget(new rmps.ui.SimpleButton({
					label: rhpMessages.new_review,
					onClick: dojo.hitch(this, this._onNewReview)
				}));
			this.newButton.setEnabled(this._projectArea != null);
		
		this.refreshButton = toolbar.addButton(this, this._onRefreshViewlet, {
				label: commonMessages.refresh,
				imgSrc: dojo.moduleUrl("rmps.app", "graphics/icons/refresh.gif")
			});	
	},

	onHashChange: function(hash) {
		var newHash = (hash != null)? hash : dojo.hash();
		var newHashObj = dojo.queryToObject(newHash);
		
		if (newHashObj.resourceUri == null)
		{
			//do nothing
		}
		else if (newHashObj.resourceUri != null &&
					(newHashObj.resourceUri != this._reviewUri) ||
					(newHashObj.ts && newHashObj.ts != this._ts))
		{
			this._reviewUri = newHashObj.resourceUri; 
			this._ts = newHashObj.ts;
			this.showReviewEditor();
		}
		if (this._reviewEditor != null)
		{
			var tab = newHashObj.tab;
			if (tab != null && tab != this._reviewEditor.getSelectedTabId())
			{
				this._reviewEditor.selectTab(tab);
			}
			//to trigger the population of the resources tab
			this._reviewEditor.resize();
		}
		
	},
	
		
	_handleWindowResize: function(event) {
		setTimeout(dojo.hitch(this, this.resize), 0);
	},
	
	resize: function() {
		/*Empty Block */
	},
	

	showStatusNode: function(text) {
		this.statusNode.innerHTML = "";
		if (text != null) {
			this.statusNode.appendChild(dojo.doc.createTextNode(text+"..."));	//$NON-NLS-1$
			this.statusNode.style.display= "inline";
		}else {
			this.statusNode.style.display= "none";			
		}
	},
	
	hideStatusNode: function() {
		this.statusNode.innerHTML = "";
		this.statusNode.style.display= "none";
	},
	

	
});



dojo.declare("com.ibm.rational.carter.ide.client.reviews.ReviewWidget._Mediator", null, {
	notifiers: null,

	constructor: function(){
		this.notifiers= [];
	},

	addNotifier: function(func){
		/*Checking for func being function or not is the caller responsability */
		this.notifiers.push(func);
	},

	removeNotifier: function(func){
		var index= dojo.indexOf(this.notifiers, func);
		if(index>-1){
			this.notifiers.splice(index, 1);
		}
	},

	execute: function(){
		for(var index=0; index<this.notifiers.length; index++){
			this.notifiers[index]();
		}
	}
});
})();
